/*
    Namazu wrapper object

    Copyright (C) 2001 KENZ@gelsoft <gelsoft@mx4.tiki.ne.jp>.
    All Rights Reserved.
*/

function Namazu(aPath) {
    this.localFile = Components.classes["@mozilla.org/file/local;1"];
    this.process = Components.classes["@mozilla.org/process/util;1"];

    // get nsILocalFile interface
    var lf = this.localFile.
        createInstance(Components.interfaces.nsILocalFile);
    if (!lf)
        throw "Can't retrieve nsILocalFile interface!!";

    // get nsIProcess interface
    this.namazu = this.process.
        createInstance(Components.interfaces.nsIProcess);
    if (!this.namazu)
        throw "Can't retrieve nsIProcess interface!!";

    // initialize namazu object
    lf.initWithPath(aPath);
    this.namazu.init(lf);
}

Namazu.prototype = {
    outputPath: null,
    indexes: null,
    max: 9,
    search: function (aKeyword) {
        if (!this.outputPath)
            return false;
        if (!this.indexes)
            return false;

/*
        var arg = ["--max=" + this.max, "--output=" + this.outputPath,
            aKeyword];
*/
        var arg = ["--all", "--config=/etc/namazu/namazurc",
            "--output=" + this.outputPath, aKeyword];
            dummy = {};
        for (var i = 0; i < this.indexes.length; i++)
            arg.push(this.indexes[i]);

        this.namazu.run(true, arg, arg.length, dummy);

        return true;
    },
};

